# Java Collections

## Getting started

1. Open `io.humb1t.Main.java` and compare different approaches in iterations. Write down your thoughts,
what is your favourite option? Which one is easier to read and which one is easier to write? Why?
2. Add numeric field to `Order` class, use it to filter collection of orders by some criteria
(more than 50 order items for example).
3. Imagine the situation - you need to implement [queue](https://en.wikipedia.org/wiki/Queue_(abstract_data_type\))
of incoming requests, to process incoming requests we have 3 independent "processors".
How can we design our application in such a case and what pros and cons we would face in different approaches?
Write down your thoughts and implement one possible solution.
4. Imagine the situation when you have a `Collection` and should remove all duplicates in it.
How would you do it? Implement your solution using only Java SE.
5. There is an old war between `ArrayList` and `Linked List` - choose new fighters and implement your
own benchmark (`Vector` vs `Queue` for example). Write down your thoughts.
6. `Map` is very good in implementation of simple [caches](https://en.wikipedia.org/wiki/Cache_(computing\)).
Implement your own cache using `Map`.


